
/*
	protocol.h

	Xmodem declaration header file for
	use with Lattice C ver 2.14

	Copyright (c) 1984, 1985 Larry Jordan Associates

	ver 1.0
	8/1/85

*/


/* Xmodem defines */


#define CPMEOF	26		/* control/z */
#define OVERWRITE 1		/* define for normal overwrite */
#define MAXERRORS 10		/* max number of times to retry one block */
#define OVRWRITIM 10		/* time to pause, none if OVERWRITE defined */
#define SECSIZE 128		/* cpm sector, transmission block */
#define XMSIZE	132		/* Xmodem packet size */
#define SENTIMOUT 120		 /* timeout time in send */
#define SLEEP	30		/* timeout time in recv */
#define RECSIZE    250		/* buffer size for strings */

/* Xmodem protocol characters used */

#define SOH	1	/* Start Of Header */
#define EOT	4	/* End Of Transmission */
#define ACK	6	/* ACKnowlege */
#define NAK	0x15	/* Negative AcKnowlege */
#define CAN	0x18	/* Cancel */
#define DEBUG	1
#define CTRLZ	26    /* ASCII End Of File marker and upload end signal */
#define CTRLX	24    /* abort file transfer signal from caller */

#define TIMEOUT (-1)
#define BADDIR	2
#define ABORT	(-1)
#define INCNAME 2
#define CDLOST (-1)
